# (New Name: BestWeather.tcl) Highly Modified and re-written by DragonFlu
# weatherNOSPAM@dragonflu.com
# Please remove the NOSPAM from email address to email me.
# http://www.dragonflu.com/weather
# Version 1.6.2 for eggdrop 1.6.* Dated 8-14-2004
# For Quality Shell Accounts, Web Hosting and IRCD's, WWW.ACMESHELLS.COM


# Original Version used XML.
# Written by Kirrilian (Glen)
# www.tenacious.us/projects/code/
# kirrilian@hotmail.com

# Parts of this script were taken from other tcls:
# Find v2.0 by MC_8 - Carl M. Gregory <gregory@worldinter.net>
# Weather V3.3.4 by Murf http://www.blueday.org/eggdrop.html


# Configuration Settings.

# Set this to the following for displaying weather to users:
# weather(display) is just for the normal weather
# weather(displayforcast) is obviously for the forecasts
# its seperate cause it can be quite a long display.
# 1 = Private Notice
# 2 = Private Message
# 3 = Public Notice
# 4 = Public Message

set weather(display) 4

# How do you want the .wzf (forecast displayed)?

set weather(displayforcast) 2

# What channels do you want .wz/.wzf to function in? Seperate EACH channel with a SPACE.
# to have it work in ALL channels, just put in the word all, ie: set weather(channels) "all"
set weather(channels) "#acmeshells #abuse #acme-staff"

# Flood Protection: This will be set to ignore a user if the bot starts being flooded with requests
# more than 3 requests in 5 second triggers flood, set to 0:0 to disable.

set weather(flood) 3:5

# Ignore Time: Set to how many minutes you wish to ignore the user.

set weather(ignore) 2

# set the default bind flags here
# examples...
# -|- anyone
# o|o only ops
# f|f only friends
# of|of friends or ops
# weather(nflags) is for the normal weather display
# weather(fflags) is for the forecast display

set weather(nflags) "-|-"
set weather(fflags) "-|-"

# What commands do you want the bot to respond to for weather and forcast weather?

set weather(normal) ".wz"
set weather(forcast) ".wzf"


# STOP - GO NO FURTHER - THERE IS NOTHING TO SEE BELOW THIS LINE #




































# STOP - GO NO FURTHER - THERE IS NOTHING TO SEE BELOW THIS LINE #

bind pub $weather(nflags) $weather(normal) wzoutput
bind pub $weather(fflags) $weather(forcast) wzfoutput   

switch -- $weather(display) {
 1 {set weather(display) "NOTICE %nick"}
 2 {set weather(display) "PRIVMSG %nick"}
 3 {set weather(display) "NOTICE %chan"}
 4 {set weather(display) "PRIVMSG %chan"}
 default {set weather(display) "PRIVMSG %chan"}
}

switch -- $weather(displayforcast) {
 1 {set weather(displayforcast) "NOTICE %nick"}
 2 {set weather(displayforcast) "PRIVMSG %nick"}
 3 {set weather(displayforcast) "NOTICE %chan"}
 4 {set weather(displayforcast) "PRIVMSG %chan"}
 default {set weather(displayforcast) "PRIVMSG %chan"}
}

proc wzoutput { nick host hand chan text } {
	global weather
	set temp ""
	set location ""
	set updated "" 
	set windchill ""
	set humidity ""
	set conditions ""
	set wind ""
	set sunrise ""
	set sunset ""
	set visibility ""
	set barometer ""
	set dewpoint ""
	set heatindex ""
	set moonphase ""
   	if {![string match "*[string tolower $chan]*" " [string tolower $weather(channels)] "] && ![string match "*all*" " [string tolower $weather(channels)] "]} {
		return 0
	}
	if {[mc:find:inter:flood [string range $host [expr [string last @ $host]+1] e]]} {return 0}
	if {[regexp {[0-9]} $text] == 1 && [string length $text] == 5} { 
		set wzsock [socket -async www.weatherroom.com 80]
		puts $wzsock "GET /weather?forecast=zandh&pands=$text"
	        flush $wzsock
		set i 1
		for {set i 0} {$i <= 500} {incr i} {
			incr i
			set output [gets $wzsock]
                                if {[string match "*<title>*" $output]} {
                                        regexp {title> (.+) - Local} $output match location
                                }
                                if {[string match "*Updated*" $output]} {
                                        regexp {small>(.+)</small} $output match updated
                                }
				if {[string match "*Temp:*" $output]} {
					set output [gets $wzsock]
			                regexp {arial">(.*)</font} $output match temp
					if {$temp != "N/A"} {
					regexp {(.*)F} $temp match ctemp
					regsub -all "°F" $ctemp "" ctemp
                                        set ctemp [expr ($ctemp - 32) * 5 / 9]
                                        set temp "$temp/$ctempC"
					} else {
						set temp "N/A"
					}
				}
                                if {[string match "*Humidity*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match humidity
                                }
                                if {[string match "*Wind Speed*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match wind
                                }
                                if {[string match "*Barometer*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">    (.*)   </font} $output match barometer
					if {$barometer != ""} {
	                                        set barometer [string range "$barometer        " 0 8]
                                        } else {
                                                set barometer "N/A"
                                        }
                                }
                                if {[string match "*Dewpoint*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match dewpoint
					if {$dewpoint != "N/A"} {
                                        regexp {(.*)F} $dewpoint match cdewpoint
                                        regsub -all "°F" $cdewpoint "" cdewpoint
                                        set cdewpoint [expr ($cdewpoint - 32) * 5 / 9]
                                        set dewpoint "$dewpoint/$cdewpointC"
                                        } else {
                                                set dewpoint "N/A"
                                        }
                                }
                                if {[string match "*Heat Index*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match heatindex
					if {$heatindex != "N/A"} {
					regsub -all "&deg;" $heatindex "" heatindex
                                        regexp {(.*)F} $heatindex match cheatindex
                                        regsub -all "°F" $cheatindex "" cheatindex
                                        set cheatindex [expr ($cheatindex - 32) * 5 / 9]
                                        set heatindex "$heatindex/$cheatindexC"
                                        } else {
                                                set heatindex "N/A"
                                        }
                                }
                                if {[string match "*Wind Chill*" $output]} { 
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match windchill
					if {$windchill != "N/A"} {
                                        regexp {(.*)F} $windchill match cwindchill             
                                        regsub -all "°F" $cwindchill "" cwindchill
                                        set cwindchill [expr ($cwindchill - 32) * 5 / 9]
                                        set windchill "$windchill/$cwindchillC"
                                        } else {
                                                set windchill "N/A"
                                        }
                                }			
                                if {[string match "*Sunrise:*" $output]} {
                                       set output [gets $wzsock]
                                        regexp {size="-1">(.*)</font} $output match sunrise
                                        set sunrise [string range "$sunrise            " 0 12]
                                }
                                if {[string match "*Sunset:*" $output]} {
                                        set output [gets $wzsock]
					regexp {size="-1">(.*)</font} $output match sunset
                                        set sunset [string range "$sunset            " 0 12] 
                                }
                                if {[string match "*Moon Phase*" $output]} {
                                       set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match moonphase
                                }
		}
		puthelp "[mc:find:inter:replace $weather(display) "%nick $nick %chan $chan"] :\002$location\002 - $updated"
                puthelp "[mc:find:inter:replace $weather(display) "%nick $nick %chan $chan"] :\002$location\002 - $updated"
		puthelp "[mc:find:inter:replace $weather(display) "%nick $nick %chan $chan"] :\002Temp:\002 [format %-12s $temp] \002Windchill:\002 [format %-12s $windchill] \002Dewpoint:\002 [format %-12s $dewpoint] \002Heatindex:\002 [format %-12s $heatindex] \002Barometer:\002 $barometer"
                puthelp "[mc:find:inter:replace $weather(display) "%nick $nick %chan $chan"] :\002Humidity:\002 [format %-7s $humidity]  \002Wind:\002 [format %-17s $wind] \002Sunrise:\002 $sunrise \002Sunset:\002 $sunset \002Moonphase:\002 $moonphase"
		puthelp "[mc:find:inter:replace $weather(display) "%nick $nick %chan $chan"] :\002Powered By:\002 www.weatherroom.com - \002Written by:\002 DragonFlu (www.dragonflu.com/weather)"
		close $wzsock
	} else {
		puthelp "[mc:find:inter:replace $weather(display) "%nick $nick %chan $chan"] :Sorry that is an invalid entry"
		wzhelp $nick
        }
	return 0
}

proc mc:find:inter:replace {string subs} {
 if {[llength $subs] == "1"} {set subs [lindex $subs 0]}
 for {set i 0} {[lindex $subs $i] != ""} {incr i 2} {
  regsub -all -- [lindex $subs $i] $string [lindex $subs [expr $i+1]] string
 } ; return $string
}

proc wzfoutput { nick host hand chan text } {
	global weather
        set temp ""
        set location ""
        set updated ""
        set windchill ""
        set humidity ""
        set conditions ""
        set wind ""
        set sunrise ""
        set sunset ""
        set visibility ""
        set barometer ""
        set dewpoint ""
        set heatindex ""
        set moonphase ""
	set fday ""
	set fday2 ""
	set fday3 ""
	set fday4 ""
	set fday5 ""
	set fday6 ""
        set fcast1 ""
        set fcast2 ""
        set fcast3 ""
	set fcast4 ""
	set fcast5 ""
	set fcast6 ""
	set fcast7 ""
	set fcast8 ""
        set fdated ""
	string tolower $text
        if {![string match "*[string tolower $chan]*" " [string tolower $weather(channels)] "] && ![string match "*all*" " [string tolower $weather(channels)] "]} {
        	return 0
        }
	putserv "PRIVMSG $chan :Sending weather forcast to $nick in msg."
        if {[mc:find:inter:flood [string range $host [expr [string last @ $host]+1] e]]} {return 0}
        if {[regexp {[0-9]} $text] == 1 && [string length $text] == 5} {
		set wzsock [socket -async www.weatherroom.com 80]
                puts $wzsock "GET /weather?forecast=zandh&pands=$text"
                flush $wzsock
                set i 1
                while {$i < 500} {
                	incr i
	                set output [gets $wzsock]
                                if {[string match "*<title>*" $output]} { 
					regexp {title> (.+) - Local} $output match location
                                }
                                if {[string match "*Updated*" $output]} {
                                        regexp {small>(.+)</small} $output match updated
                                }
                                if {[string match "*Temp:*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match temp
					if {$temp != "N/A"} {
                                        regexp {(.*)F} $temp match ctemp
                                        regsub -all "°F" $ctemp "" ctemp
                                        set ctemp [expr ($ctemp - 32) * 5 / 9]
                                        set temp [string range "$temp/$ctempC         " 0 10]
                                        } else {
                                                set temp "N/A"
                                        }
                                }
                                if {[string match "*Humidity*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match humidity
                                        set humidity [string range "$humidity     " 0 6]
                                }
                                if {[string match "*Wind Speed*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match wind
                                        set wind [string range "$wind          " 0 10]
                                }
                                if {[string match "*Barometer*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">    (.*)   </font} $output match barometer
					if {$barometer != ""} {
	                                        set barometer [string range "$barometer        " 0 8]
                                        } else {
                                                set barometer "N/A"
                                        }
                                }
                                if {[string match "*Dewpoint*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match dewpoint
					if {$dewpoint != "N/A"} {
                                       regexp {(.*)F} $dewpoint match cdewpoint
                                        regsub -all "°F" $cdewpoint "" cdewpoint
                                        set cdewpoint [expr ($cdewpoint - 32) * 5 / 9]
                                        set dewpoint [string range "$dewpoint/$cdewpointC            " 0 10]
                                        } else {
                                                set dewpoint "N/A"
                                        }
                                }
                                if {[string match "*Heat Index*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match heatindex
					if {$heatindex != "N/A"} {
                                        regsub -all "&deg;" $heatindex "" heatindex
                                        regexp {(.*)F} $heatindex match cheatindex
                                        regsub -all "°F" $cheatindex "" cheatindex
                                        set cheatindex [expr ($cheatindex - 32) * 5 / 9]
                                        set heatindex [string range "$heatindex/$cheatindexC            " 0 10]
                                        } else {
                                                set heatindex "N/A"
                                        }
                                }
                                if {[string match "*Wind Chill*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match windchill
					if {$windchill != "N/A"} {
                                        regexp {(.*)F} $windchill match cwindchill
                                        regsub -all "°F" $cwindchill "" cwindchill
                                        set cwindchill [expr ($cwindchill - 32) * 5 / 9]
                                        set windchill [string range "$windchill/$cwindchillC            " 0 10]
                                        } else {
                                                set windchill "N/A"
                                        }
                                }
                                if {[string match "*Sunrise:*" $output]} {
                                       set output [gets $wzsock]
                                        regexp {size="-1">(.*)</font} $output match sunrise
                                        set sunrise [string range "$sunrise            " 0 12]
                                }
                                if {[string match "*Sunset:*" $output]} {
                                        set output [gets $wzsock]
                                        regexp {size="-1">(.*)</font} $output match sunset
                                        set sunset [string range "$sunset            " 0 12]
                                }
                                if {[string match "*Moon Phase*" $output]} {
                                       set output [gets $wzsock]
                                        regexp {arial">(.*)</font} $output match moonphase
                                }
                                if {[string match "*Rest Of Today*" $output]} {
                                        regexp {/b>(.*)</font> <br><br>} $output match fcast1
                                }
                                if {[string match "*Tonight*" $output]} {
                                        regexp {/b>(.*)</font> <br><br>} $output match fcast2
					set output [gets $wzsock]
                                        set output [gets $wzsock]
					regexp {b>(.*)</b} $output match fday
					regexp {/b>(.*)</font> <br><br>} $output match fcast3
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        regexp {b>(.*)</b} $output match fday2
                                        regexp {/b>(.*)</font> <br><br>} $output match fcast4
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        regexp {b>(.*)</b} $output match fday3
                                        regexp {/b>(.*)</font> <br><br>} $output match fcast5
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        regexp {b>(.*)</b} $output match fday4
                                        regexp {/b>(.*)</font> <br><br>} $output match fcast6
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        regexp {b>(.*)</b} $output match fday5
                                        regexp {/b>(.*)</font> <br><br>} $output match fcast7
                                        set output [gets $wzsock]
                                        set output [gets $wzsock]
                                        regexp {b>(.*)</b} $output match fday6
                                        regexp {/b>(.*)</font> <br><br>} $output match fcast8
                                }
                                if {[string match "*Dated:*" $output]} {
                                        regexp {font size="1">(.*)</font>} $output match fdated
                                }
                }
		close $wzsock
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :\002$location\002 - $updated"
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :\002Temp:\002 $temp \002Windchill:\002 $windchill \002Dewpoint:\002 $dewpoint \002Heatindex:\002 $heatindex \002Barometer:\002 $barometer"
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :\002Humidity:\002 $humidity \002Wind:\002 $wind \002Sunrise:\002 $sunrise \002Sunset:\002 $sunset \002Moonphase:\002 $moonphase"
		puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :\002Forcast Dated:\002 $fdated"
		if {$fcast1 != ""} {
                	puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002Rest Of Today\002 $fcast1"  
		}
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002Tonight\002 $fcast2"
		puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002$fday\002 $fcast3"
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002$fday2\002 $fcast4"
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002$fday3\002 $fcast5"
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002$fday4\002 $fcast6"
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002$fday5\002 $fcast7"
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] :  \002$fday6\002 $fcast8"
        } else {
                puthelp "[mc:find:inter:replace $weather(displayforcast) "%nick $nick %chan $chan"] : Sorry that is an invalid entry"
                wzhelp $nick
        }
        return 0
}

proc wzhelp {nick} {
	puthelp "NOTICE $nick : Usage: Type .wz zipcode or .wzf zipcode for the forcast (Currently works ONLY on US Zip Codes)"
}

proc mc:find:inter:flood {uhost} {
 global lastbind weather_f weather
 set a [lindex [split $weather(flood) :] 0] ; set b [lindex [split $weather(flood) :] 1]
 if {[info exists weather_f($uhost)]} {
  incr weather_f($uhost) 1
  if {$weather_f($uhost) > $a} {
   newignore *!*@$uhost weather Flood $weather(ignore)
   return 1
  }
 } {set weather_f($uhost) 1}
 if {![string match "*unset weather_f($uhost)*" [utimers]]} {
  utimer $b "catch {unset weather_f($uhost)}"
 } ; return 0
}

putlog "BestWeather by Dragonflu (www.dragonflu.com/weather), Original Version by: Kirrilian"
